/*----------------------------------------------*/
/*						*/
/*		BUILDINDEXES.C			*/
/*						*/
/* This file contains the functions to build	*/
/* the index structure for the CBR. The		*/
/* functions to create the nodes are in the	*/
/* casesnn file.				*/
/*----------------------------------------------*/


/* main index building procedure */

void buildindexes()
{
struct indexnamenode *pointer;

 pointer = indexnameroot;

 while (pointer != NULL)	/* for all index fields */
   {
    makeindex(pointer);	/* create index for this field */
    pointer = pointer->indexnamelink;
   }

}


void makeindex(name)
struct indexnamenode *name;
{
struct enumnode *enumptr;
struct typenode *fieldptr;

 fieldptr = findfield(name->fieldname,probdefnroot);/* find the field in the definition */

 if (fieldptr == NULL)
   {
    fprintf(stderr,"Huh? - fieldname %s not defined\n",name->fieldname);
    exit(1);
   }

 enumptr = fieldptr->enumhead;

 while (enumptr != NULL)	/* for all enumeration values */
   {
    addindexnode(name,enumptr);	/* scan the cases for matching values */
    enumptr = enumptr->enumlink;
   }

}


/* find case links for this enumeration value */
void addindexnode(name, enumptr)
struct indexnamenode *name;
struct enumnode *enumptr;
{
struct indexnode *pointer;
struct caseptrnode *caseptrlist;

 /* create a case pointer list for all cases with this value in this field */
 caseptrlist = makecaseptrlist(name->fieldname,enumptr->evalue,caseroot);

 if (caseptrlist != NULL)
   {
    pointer = createindexnode(enumptr->evalue);
    pointer->caseptrhead = caseptrlist;
    pointer->indexlink = name->indexhead;	/* add indexnode to head of list */
    name->indexhead = pointer;
   }
}


/* build a case pointer list for a given field & value */
struct caseptrnode *makecaseptrlist(fieldname,value,caseptr)
buftype *fieldname,*value;
struct casenode *caseptr;
{
struct caseptrnode *caseptrptr,*tail;

 if (caseptr == NULL)	/* reached end of case list */
   {
    return NULL;
   }
 else
   {			/* do tail first */
    tail = makecaseptrlist(fieldname,value,caseptr->caselink);
    if (strcmp(getfieldvalue(caseptr,fieldname),value) == 0)	/* values match */
      {
       caseptrptr = createcaseptrnode(caseptr);
       caseptrptr->caseptrlink = tail;	/* create a node and stick the tail in */
       return caseptrptr;
      }
    else
      {
       return tail;
      }
   }
}


/* return the enumeration value of the named field in the given case */

buftype *getfieldvalue(caseptr,fieldname)
struct casenode *caseptr;
buftype *fieldname;
{
struct fieldnode *fieldptr;

 fieldptr = caseptr->fieldhead;	/* start of fieldlist */

 while (fieldptr != NULL)
   {
    if (strcmp(fieldptr->fieldname,fieldname) == 0)
      {
       return fieldptr->strcontents;
      }
    fieldptr = fieldptr->fieldlink;
   }

 fprintf(stderr,"Error - indexed field %s value undefined in case %s\n",
                   fieldname,caseptr->name);
 exit(1);
}
